<template>
  <ion-page>
    <page-top-bar
      :needBackButton="true"
      :needEmitBackEvent="true"
      @back="confirmCancellation"
      :title="`${t('creation_goal.header', {}, { locale: $store.state.appLang })}`"
    />
    <ion-content>
      <div class="p-5 pb-20 empty-content">
        <div>
          <ion-text class="flex text-left justify-center mb-3">
            {{ t("creation_goal.type_title", {}, { locale: $store.state.appLang }) }}
          </ion-text>
        </div>
        <div class="flex relative justify-center text-left">
          <ion-input
            v-model="$store.state.createdGoal.title"
            class="no-padding-input border"
            maxlength="70"
          />
          <ion-text
            color="medium"
            v-if="$store.state.createdGoal.title"
            class="absolute bottom-0 right-0 pr-6 text-xs"
          >
            {{ 70 - $store.state.createdGoal.title.length }}
          </ion-text>
        </div>
        <div class="flex justify-center text-left mt-10">
          <ion-button
            :disabled="!$store.state.createdGoal.title"
            @click="goToDescriptionCreation"
            class="flex"
          >
            {{ t("creation_goal.next", {}, { locale: $store.state.appLang }) }}
          </ion-button>
        </div>
      </div>
    </ion-content>
  </ion-page>
</template>

<script>
import { defineComponent } from "vue";
import {
  IonPage,
  IonInput,
  IonText,
  IonButton,
  IonContent,
  alertController,
} from "@ionic/vue";
import { useI18n } from "vue-i18n";
import PageTopBar from "../../components/PageTopBar.vue";
import firebaseAnalyticsService from "../../services/firebase-analytics";

export default defineComponent({
  components: {
    PageTopBar,
    IonPage,
    IonInput,
    IonButton,
    IonContent,
    IonText,
  },
  setup() {
    const { t, locale } = useI18n();
    return {
      t,
      locale,
    };
  },
  methods: {
    goToDescriptionCreation() {
      this.$router.push({ name: "CreationGoalDescription" });
    },
    async confirmCancellation() {
      const alert = await alertController.create({
        message:
          "<strong>" +
          this.t(
            "creation_goal.confirm_cancellation",
            {},
            { locale: this.$store.state.appLang }
          ) +
          "</strong>",
        buttons: [
          {
            text: `${this.t("actions.close", {}, { locale: this.$store.state.appLang })}`,
            role: "cancel",
          },
          {
            text: `${this.t("actions.cancel", {}, { locale: this.$store.state.appLang })}`,
            role: "destructive",
            handler: () => {
              this.$store.dispatch("deleteCreatedGoal");
              this.$router.back();
            },
          },
        ],
      });
      return alert.present();
    },
  },
  mounted() {
    firebaseAnalyticsService.logEvent("goal_creation_title_page");
  },
});
</script>

<style scoped>
.border {
  border: var(--ion-color-primary) solid 1px;
  border-radius: 10px;
}

ion-input {
  --padding-end: 5px;
  --padding-start: 5px;
  margin-right: 20px;
  margin-left: 20px;
}
</style>
